angular.module('wemModals', ['ui.bootstrap', 'i18n'])
    .service("genericModal", function($modal) {
        this.newAlertModal = function (modalData, okCallback, cancelCallback) {
            var modalInstance = $modal.open({
                templateUrl: ManagersContext.localTemplatesPath + '/modal/alert-modal.html',
                controller: 'AlertModalCtrl',
                size: 'sm',
                resolve: {
                    "modalData": function () {
                        return modalData;
                    }
                }
            });

            modalInstance.result.then(function () {
                if(okCallback){
                    okCallback();
                }
            }, function () {
                if (cancelCallback) {
                    cancelCallback();
                }
            });
        }
    })

    .controller('AlertModalCtrl', ['$scope', '$modalInstance', 'i18nService', 'modalData',
        function ($scope, $modalInstance, i18nService, modalData) {
            $scope.modal = modalData;
            if(!$scope.modal.okMsg) {
                $scope.modal.okMsg = i18nService.message("wem.ok");
            }
            if(!$scope.modal.cancelMsg) {
                $scope.modal.cancelMsg = i18nService.message("wem.cancel");
            }

            $scope.ok = function () {
                $modalInstance.close();
            };

            $scope.cancel = function () {
                $modalInstance.dismiss('cancel');
            }
        }]);