<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="wem" uri="http://www.jahia.org/tags/wem" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="subchild" type="org.jahia.services.content.JCRNodeWrapper"--%>
<c:set var="editableVariants" scope="request" value="${editableModule}"/>

<template:include view="editToolbar"/>

<c:if test="${not renderContext.editMode or not editableVariants}">
    <c:if test="${not empty currentNode.properties['wem:controlVariant'].string}">
        <%-- Fallback variant is explicitly specified --%>
        <c:set var="controlVariant" value="${currentNode.properties['wem:controlVariant'].node}"/>
    </c:if>
    <c:set var="optimizationActive" value="${wem:isOptimizationActive(currentNode)}"/>
    <c:set var="ajaxRender" value="${empty currentNode.properties['wem:ajaxRender'] or currentNode.properties['wem:ajaxRender'].boolean}"/>

    <c:if test="${optimizationActive and currentResource.workspace eq 'live'}">
        <template:addResources type="javascript" resources="jquery.min.js"/>
        <c:set var="elementID" value="wemoptimized-${currentNode.identifier}" />
        <c:set var="parsedId" value="${fn:replace(currentNode.identifier,'-','_')}"/>

        <div id="${elementID}">
            <c:if test="${not ajaxRender}">
                <c:forEach items="${moduleMap.variants}" var="subchild" varStatus="st">
                    <div style="display: none" id="wem${parsedId}${st.index}">
                        <template:module node="${subchild}" nodeTypes="${requestScope[constraints] == 'jmix:droppableContent' ? '' : requestScope[constraints]}" />
                    </div>
                </c:forEach>
            </c:if>
        </div>

        <script type="text/javascript">
            (function(){
                var variants = {
                    <c:forEach items="${moduleMap.variants}" var="subchild" varStatus="varStatus">
                    '${subchild.identifier}' : {
                        <c:if test="${not ajaxRender}">
                        "content": "wem${parsedId}${varStatus.index}"
                        </c:if>
                        <c:if test="${ajaxRender}">
                        "content": "<c:url value="${url.base}${functions:escapePath(subchild.path)}.${functions:default(subchild.properties['j:view'].string, 'default')}.html.ajax"/>"
                        </c:if>
                    }${!varStatus.last ? ',' : ''}
                    </c:forEach>
                };

                if(window.wem) {
                    window.wem.registerOptimizationTest("${currentNode.identifier}", "${currentNode.properties['wem:goalId'].string}", "${elementID}", variants, ${ajaxRender});
                } else {
                    console.log("No wem available in page, can't register optimization.")
                }
            })();
        </script>
    </c:if>
    <c:if test="${not optimizationActive or currentResource.workspace ne 'live'}">
        <c:if test="${not empty controlVariant}">
            <template:module node="${controlVariant}"/>
        </c:if>
    </c:if>
</c:if>